<?php
namespace HCM\FPA\ObrigacaoLegal\Rais\Entities;

use HCM\FPA\ObrigacaoLegal\Rais\FormataMagnetico;

class Tipo01Base extends FormataMagnetico
{
    //ATRIBUTOS RAIS
    protected $sequencial;              //TAMANHO = 06
    protected $cnpj;                    //TAMANHO = 14
    protected $prefixo;                 //TAMANHO = 02
    protected $tipoRegistro;            //TAMANHO = 01
    protected $razaoSocial;             //TAMANHO = 52
    protected $logradouro;              //TAMANHO = 40
    protected $numero;                  //TAMANHO = 06
    protected $complemento;             //TAMANHO = 21
    protected $bairro;                  //TAMANHO = 19
    protected $cep;                     //TAMANHO = 08
    protected $codMunicipio;            //TAMANHO = 07
    protected $municipio;               //TAMANHO = 30
    protected $uf;                      //TAMANHO = 02
    protected $ddd;                     //TAMANHO = 02
    protected $numeroTel;               //TAMANHO = 09
    protected $email;                   //TAMANHO = 45
    protected $cnae;                    //TAMANHO = 07
    protected $natJuridica;             //TAMANHO = 04
    protected $numPropriet;             //TAMANHO = 04
    protected $dataBase;                //TAMANHO = 02
    protected $tipoInscricao;           //TAMANHO = 01
    protected $tipoRais;                //TAMANHO = 01
    protected $zeros;                   //TAMANHO = 02
    protected $matricula;               //TAMANHO = 12
    protected $ano;                     //TAMANHO = 04
    protected $porte;                   //TAMANHO = 01
    protected $optSimples;              //TAMANHO = 01
    protected $optPat;                  //TAMANHO = 01
    protected $patMenos5;               //TAMANHO = 06
    protected $patMais5;                //TAMANHO = 06
    protected $servicoProp;             //TAMANHO = 03
    protected $admCozinha;              //TAMANHO = 03
    protected $convenio;                //TAMANHO = 03
    protected $transportadas;           //TAMANHO = 03
    protected $cesta;                   //TAMANHO = 03
    protected $alimentConvenio;         //TAMANHO = 03
    protected $encerramento;            //TAMANHO = 01
    protected $dataEncerramento;        //TAMANHO = 08
    protected $contrAssocCnpj;          //TAMANHO = 14
    protected $contrAssocValor;         //TAMANHO = 09
    protected $contrSindiCnpj;          //TAMANHO = 14
    protected $contrSindiValor;         //TAMANHO = 09
    protected $contrAssistCnpj;         //TAMANHO = 14
    protected $contrAssistValor;        //TAMANHO = 09
    protected $contrConfedCnpj;         //TAMANHO = 14
    protected $contrConfedValor;        //TAMANHO = 09
    protected $atividadeAno;            //TAMANHO = 01
    protected $centPagSindical;         //TAMANHO = 01
    protected $centPagSindCnpj;         //TAMANHO = 14
    protected $empresaFiliSind;         //TAMANHO = 01
    protected $tipoSisContrPto;         //TAMANHO = 02
    protected $espacos;                 //TAMANHO = 85
    protected $infoExclEmpresa;         //TAMANHO = 12


    public function getRow()
    {
        try {
            $row = "";
            $lengths = array(
                'cnpj'              => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'prefixo'           => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' =>  2),
                'tipoRegistro'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'razaoSocial'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 52),
                'logradouro'        => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 40),
                'numero'            => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'complemento'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 21),
                'bairro'            => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 19),
                'cep'               => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  8),
                'codMunicipio'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  7),
                'municipio'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 30),
                'uf'                => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' =>  2),
                'ddd'               => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  2),
                'numeroTel'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'email'             => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 45, 'ESPECIAL' => true),
                'cnae'              => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  7),
                'natJuridica'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  4),
                'numPropriet'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  4),
                'dataBase'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  2),
                'tipoInscricao'     => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'tipoRais'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'zeros'             => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  2),
                'matricula'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 12),
                'ano'               => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  4),
                'porte'             => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'optSimples'        => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'optPat'            => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'patMenos5'         => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'patMais5'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'servicoProp'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'admCozinha'        => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'convenio'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'transportadas'     => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'cesta'             => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'alimentConvenio'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  3),
                'encerramento'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'dataEncerramento'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_DIA_MES_ANO_8D, 'TAMANHO' =>  8),
                'contrAssocCnpj'    => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'contrAssocValor'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'contrSindiCnpj'    => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'contrSindiValor'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'contrAssistCnpj'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'contrAssistValor'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'contrConfedCnpj'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'contrConfedValor'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  9),
                'atividadeAno'      => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'centPagSindical'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'centPagSindCnpj'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'empresaFiliSind'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'tipoSisContrPto'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  2),
                'espacos'           => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 85),
                'infoExclEmpresa'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 45)
            );

            foreach($lengths as $name=>$length){
                $row.=$this->setData($this->$name,$length);
            }

            return $row;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    
    public function getAdmCozinha()
    {
        return $this->admCozinha;
    }

   
    public function setAdmCozinha($admCozinha)
    {
        $this->admCozinha = $admCozinha;
    }

  
    public function getAlimentConvenio()
    {
        return $this->alimentConvenio;
    }

    
    public function setAlimentConvenio($alimentConvenio)
    {
        $this->alimentConvenio = $alimentConvenio;
    }

   
    public function getAno()
    {
        return $this->ano;
    }

  
    public function setAno($ano)
    {
        $this->ano = $ano;
    }

   
    public function getAtividadeAno()
    {
        return $this->atividadeAno;
    }

    
    public function setAtividadeAno($atividadeAno)
    {
        $this->atividadeAno = $atividadeAno;
    }

    
    public function getBairro()
    {
        return $this->bairro;
    }

    
    public function setBairro($bairro)
    {
        $this->bairro = $bairro;
    }

    
    public function getCentPagSindCnpj()
    {
        return $this->centPagSindCnpj;
    }

    
    public function setCentPagSindCnpj($centPagSindCnpj)
    {
        $this->centPagSindCnpj = $centPagSindCnpj;
    }

    
    public function getCentPagSindical()
    {
        return $this->centPagSindical;
    }


    public function setCentPagSindical($centPagSindical)
    {
        $this->centPagSindical = $centPagSindical;
    }

   
    public function getCep()
    {
        return $this->cep;
    }

    public function setCep($cep)
    {
        $this->cep = $cep;
    }

    
    public function getCesta()
    {
        return $this->cesta;
    }

    public function setCesta($cesta)
    {
        $this->cesta = $cesta;
    }

    public function getCnae()
    {
        return $this->cnae;
    }

    public function setCnae($cnae)
    {
        $this->cnae = $cnae;
    }

    public function getCnpj()
    {
        return $this->cnpj;
    }

    public function setCnpj($cnpj)
    {
        $this->cnpj = $cnpj;
    }

    public function getCodMunicipio()
    {
        return $this->codMunicipio;
    }

    public function setCodMunicipio($codMunicipio)
    {
        $this->codMunicipio = $codMunicipio;
    }

    public function getComplemento()
    {
        return $this->complemento;
    }

    public function setComplemento($complemento)
    {
        $this->complemento = $complemento;
    }

    public function getContrAssistCnpj()
    {
        return $this->contrAssistCnpj;
    }

    public function setContrAssistCnpj($contrAssistCnpj)
    {
        $this->contrAssistCnpj = $contrAssistCnpj;
    }

    public function getContrAssistValor()
    {
        return $this->contrAssistValor;
    }

    public function setContrAssistValor($contrAssistValor)
    {
        $this->contrAssistValor = $contrAssistValor;
    }

    public function getContrAssocCnpj()
    {
        return $this->contrAssocCnpj;
    }

    public function setContrAssocCnpj($contrAssocCnpj)
    {
        $this->contrAssocCnpj = $contrAssocCnpj;
    }

    public function getContrAssocValor()
    {
        return $this->contrAssocValor;
    }

    public function setContrAssocValor($contrAssocValor)
    {
        $this->contrAssocValor = $contrAssocValor;
    }

    public function getContrConfedCnpj()
    {
        return $this->contrConfedCnpj;
    }

    public function setContrConfedCnpj($contrConfedCnpj)
    {
        $this->contrConfedCnpj = $contrConfedCnpj;
    }

    public function getContrConfedValor()
    {
        return $this->contrConfedValor;
    }

    public function setContrConfedValor($contrConfedValor)
    {
        $this->contrConfedValor = $contrConfedValor;
    }

    public function getContrSindiCnpj()
    {
        return $this->contrSindiCnpj;
    }

    public function setContrSindiCnpj($contrSindiCnpj)
    {
        $this->contrSindiCnpj = $contrSindiCnpj;
    }

    public function getContrSindiValor()
    {
        return $this->contrSindiValor;
    }

    public function setContrSindiValor($contrSindiValor)
    {
        $this->contrSindiValor = $contrSindiValor;
    }

    public function getConvenio()
    {
        return $this->convenio;
    }

    public function setConvenio($convenio)
    {
        $this->convenio = $convenio;
    }

    public function getDataBase()
    {
        return $this->dataBase;
    }

    public function setDataBase($dataBase)
    {
        $this->dataBase = $dataBase;
    }

    public function getDataEncerramento()
    {
        return $this->dataEncerramento;
    }

    public function setDataEncerramento($dataEncerramento)
    {
        $this->dataEncerramento = $dataEncerramento;
    }

    public function getDdd()
    {
        return $this->ddd;
    }

    public function setDdd($ddd)
    {
        $this->ddd = $ddd;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function setEmail($email)
    {
        $this->email = $email;
    }

    public function getEmpresaFiliSind()
    {
        return $this->empresaFiliSind;
    }

    public function setEmpresaFiliSind($empresaFiliSind)
    {
        $this->empresaFiliSind = $empresaFiliSind;
    }

    public function getEncerramento()
    {
        return $this->encerramento;
    }

    public function setEncerramento($encerramento)
    {
        $this->encerramento = $encerramento;
    }

    public function getEspacos()
    {
        return $this->espacos;
    }

    public function setEspacos($espacos)
    {
        $this->espacos = $espacos;
    }

    public function getInfoExclEmpresa()
    {
        return $this->infoExclEmpresa;
    }

    public function setInfoExclEmpresa($infoExclEmpresa)
    {
        $this->infoExclEmpresa = $infoExclEmpresa;
    }

    public function getLogradouro()
    {
        return $this->logradouro;
    }

    public function setLogradouro($logradouro)
    {
        $this->logradouro = $logradouro;
    }


    public function getMatricula()
    {
        return $this->matricula;
    }


    public function setMatricula($matricula)
    {
        $this->matricula = $matricula;
    }

    public function getMunicipio()
    {
        return $this->municipio;
    }

    public function setMunicipio($municipio)
    {
        $this->municipio = $municipio;
    }

    public function getNatJuridica()
    {
        return $this->natJuridica;
    }

    public function setNatJuridica($natJuridica)
    {
        $this->natJuridica = $natJuridica;
    }

    public function getNumPropriet()
    {
        return $this->numPropriet;
    }

    public function setNumPropriet($numPropriet)
    {
        $this->numPropriet = $numPropriet;
    }

    public function getNumero()
    {
        return $this->numero;
    }

    public function setNumero($numero)
    {
        $this->numero = $numero;
    }

    public function getNumeroTel()
    {
        return $this->numeroTel;
    }

    public function setNumeroTel($numeroTel)
    {
        $this->numeroTel = $numeroTel;
    }

    public function getOptPat()
    {
        return $this->optPat;
    }

    public function setOptPat($optPat)
    {
        $this->optPat = $optPat;
    }

    public function getOptSimples()
    {
        return $this->optSimples;
    }

    public function setOptSimples($optSimples)
    {
        $this->optSimples = $optSimples;
    }

    public function getPatMais5()
    {
        return $this->patMais5;
    }

    public function setPatMais5($patMais5)
    {
        $this->patMais5 = $patMais5;
    }

    public function getPatMenos5()
    {
        return $this->patMenos5;
    }

    public function setPatMenos5($patMenos5)
    {
        $this->patMenos5 = $patMenos5;
    }

    public function getPorte()
    {
        return $this->porte;
    }

    public function setPorte($porte)
    {
        $this->porte = $porte;
    }

    public function getPrefixo()
    {
        return $this->prefixo;
    }

    public function setPrefixo($prefixo)
    {
        $this->prefixo = $prefixo;
    }

    public function getRazaoSocial()
    {
        return $this->razaoSocial;
    }

    public function setRazaoSocial($razaoSocial)
    {
        $this->razaoSocial = $razaoSocial;
    }
    
    public function getSequencial()
    {
        return $this->sequencial;
    }
    
    public function setSequencial($sequencial)
    {
        $this->sequencial = $sequencial;
    }

    public function getServicoProp()
    {
        return $this->servicoProp;
    }

    public function setServicoProp($servicoProp)
    {
        $this->servicoProp = $servicoProp;
    }

    public function getTipoInscricao()
    {
        return $this->tipoInscricao;
    }

    public function setTipoInscricao($tipoInscricao)
    {
        $this->tipoInscricao = $tipoInscricao;
    }

    public function getTipoRais()
    {
        return $this->tipoRais;
    }

    public function setTipoRais($tipoRais)
    {
        $this->tipoRais = $tipoRais;
    }

    public function getTipoRegistro()
    {
        return $this->tipoRegistro;
    }

    public function setTipoRegistro($tipoRegistro)
    {
        $this->tipoRegistro = $tipoRegistro;
    }

    public function getTipoSisContrPto()
    {
        return $this->tipoSisContrPto;
    }

    public function setTipoSisContrPto($tipoSisContrPto)
    {
        $this->tipoSisContrPto = $tipoSisContrPto;
    }

    public function getTransportadas()
    {
        return $this->transportadas;
    }

    public function setTransportadas($transportadas)
    {
        $this->transportadas = $transportadas;
    }

    public function getUf()
    {
        return $this->uf;
    }

    public function setUf($uf)
    {
        $this->uf = $uf;
    }

    public function getZeros()
    {
        return $this->zeros;
    }

    public function setZeros($zeros)
    {
        $this->zeros = $zeros;
    }


} 