<?php

namespace HCM\FPA\Services;

use HCM\FPA\Repository\RelatCustomSituFuncRepository;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class RelatCustomSituFuncService {

    /**
     * @var relatCustomSituFuncRepository
     */
    protected $relatCustomAdmissaoRepository;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, RelatCustomSituFuncRepository $relatCustomSituFuncRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->relatCustomSituFuncRepository = $relatCustomSituFuncRepository;
    }

    /**
     * @return array
     */

    public function getRelatCustomSituFunc($filters) {
        
        $parameters = array(
            'P_NRORG'                   => '',
            'P_NRORG_PADRAO'            => '',
            'P_DTMESCOMPETENC'          => '',
            'P_NRESTRUTLEGAL'           => '',
            'P_NRESTRUTGEREN'           => '',
            'P_NRVINCULO'               => '',
            'P_DTINICIO'                => '',
            'P_DTFINAL'                 => '',
            'P_NROCORRECAL'             => $this->hcmParameters->getNrOcorrenciaCalculo(),
            'P_NRTPMODALIDCAL'          => $this->hcmParameters->getTipoModalidadeCalculo(),
            'P_QDEDIASMIN'              => '0',
            'P_QDEDIASMAX'              => '30',
            'P_HORAFALTASMIN'           => '',
            'P_HORAFALTASMAX'           => '',
            'P_DIASSUSPENSAOMIN'        => '',
            'P_DIASSUSPENSAOMAX'        => '', 
            'P_DIASAFASTDOENCAMIN'      => '',
            'P_DIASAFASTDOENCAMAX'      => '',
            'P_DIAFALTASMIN'            => '',
            'P_DIAFALTASMAX'            => '',
            'P_DIASSUSPENSAO14020MIN'   => '',
            'P_DIASSUSPENSAO14020MAX'   => '',
            'P_DIASAFASTMATERNIDMIN'    => '',
            'P_DIASAFASTMATERNIDMAX'    => '',
            
            );
            
        foreach ($filters as $filter) {
            switch($filter['columnName']){
                case 'P_NRORG':                   $parameters['P_NRORG']                   = $filter['value']; break;
                case 'P_NRORG_PADRAO':            $parameters['P_NRORG_PADRAO']            = $filter['value']; break;
                case 'P_DTMESCOMPETENC':          $parameters['P_DTMESCOMPETENC']          = $filter['value']; break;
                case 'NRESTRUTLEGAL':             $parameters['P_NRESTRUTLEGAL']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'NRESTRUTGEREN':             $parameters['P_NRESTRUTGEREN']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'NRVINCULOM':                $parameters['P_NRVINCULO']               = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                case 'DTINICIO':                  $parameters['P_DTINICIO']                = $filter['value']; break;
                case 'DTFINAL':                   $parameters['P_DTFINAL']                 = $filter['value']; break;
                case 'QDEDIASMIN':                $parameters['P_QDEDIASMIN']              = $filter['value']; break;
                case 'QDEDIASMAX':                $parameters['P_QDEDIASMAX']              = $filter['value']; break;
                case 'HORAFALTASMIN':             $parameters['P_HORAFALTASMIN']           = $filter['value']; break;
                case 'HORAFALTASMAX':             $parameters['P_HORAFALTASMAX']           = $filter['value']; break;
                case 'DIAFALTASMIN':              $parameters['P_DIAFALTASMIN']            = $filter['value']; break;
                case 'DIAFALTASMAX':              $parameters['P_DIAFALTASMAX']            = $filter['value']; break;
                case 'DIASSUSPENSAOMIN':          $parameters['P_DIASSUSPENSAOMIN']        = $filter['value']; break;
                case 'DIASSUSPENSAOMAX':          $parameters['P_DIASSUSPENSAOMAX']        = $filter['value']; break;
                case 'DIASAFASTDOENCAMIN':        $parameters['P_DIASAFASTDOENCAMIN']      = $filter['value']; break;
                case 'DIASAFASTDOENCAMAX':        $parameters['P_DIASAFASTDOENCAMAX']      = $filter['value']; break;
                case 'DIASSUSPENSAO14020MIN':     $parameters['P_DIASSUSPENSAO14020MIN']   = $filter['value']; break;
                case 'DIASSUSPENSAO14020MAX':     $parameters['P_DIASSUSPENSAO14020MAX']   = $filter['value']; break;
                case 'DIASAFASTMATERNIDMIN':      $parameters['P_DIASAFASTMATERNIDMIN']    = $filter['value']; break;
                case 'DIASAFASTMATERNIDMAX':      $parameters['P_DIASAFASTMATERNIDMAX']    = $filter['value']; break;
            }
        }
        
        set_time_limit(0);
        ini_set('memory_limit', '2048M');

        return $this->relatCustomSituFuncRepository->getRelatCustomSituFunc($parameters);
    }
    

} 