<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 02/08/2016
 * Time: 18:15
 */

namespace HCM\FPA\Services;

use Folha\Entities\VabBeneficiario;
use Folha\Logic\Cadastros\Evento\EventoRelacionado;
use HCM\Util\HCMParameters;
use HCM\Util\FPA;
use HCM\FPA\Repository\BloqueioEventoVinculoRepository;

class VincEventoService {

    public function __construct(FPA $fpa, HCMParameters $hcmParameters, BloqueioEventoVinculoRepository $bloqueioVinculoRepository) {
        $this->hcmParameters = $hcmParameters;
        $this->bloqueioEventVincRepository = $bloqueioVinculoRepository;
    }

    public function verificaEventoRelacBeneficiario($nrorg, $nrvincevento)
    {
        $beneficiarios = VabBeneficiario::findByNrorgAndNrvincevento($nrorg, $nrvincevento);
        if (count($beneficiarios) > 0) {
            return true;
        }
        return false;
    }

    public function cadastroAutomatico($nrorg, $dtinivigencia, $dtfimvigencia, $idtipomovimento, $nreventom,
                $vrpisoevento, $vrtetoevento, $nrvalreferencia, $vrpercent, $vrmultiplic, $vrdivide, $vreventofixo,
                $idrefgerar, $vrreffixo, $idretreferencia, $periodicidademes, $array_nrvinculom, $nrestruturam, $idgeraafastado = null)
    {
        try {
            $eventoRelac = new EventoRelacionado($nrorg, EventoRelacionado::VINCULO, $dtinivigencia, $dtfimvigencia, $idtipomovimento, $nreventom,
                $vrpisoevento, $vrtetoevento, $nrvalreferencia, $vrpercent, $vrmultiplic, $vrdivide, $vreventofixo,
                $idrefgerar, $vrreffixo, $idretreferencia, $periodicidademes, $nrestruturam, $idgeraafastado);

            $eventoRelac->cadastrarEventoRelacionado($array_nrvinculom);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function verificaEventoBloqueado ($nrorg, $nrevento, $tipoVinculo) {
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        $nrorg_padrao = $this->hcmParameters->getNrorgPadrao();
        return $this->bloqueioEventVincRepository->retornaEventosBloqueados($nrorg, $nrorg_padrao, $dtmescompetenc, $nrevento, $tipoVinculo);
    }

} 