<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class S2240Repository {

  protected $conection;

  public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
    $this->connection = $entityManager->getConnection();
    $this->entityManager = $entityManager;
    $this->hcmParameters = $hcmParameters;
  }

  public function getItensParaEnvioS2240($dataset) {
    $sql = "
SELECT MO.NRVINCULOM as NRCHAVE,
       MO.NRVINCULOM,
       '' as NRTABELA,
       DECODE(ENV.ENVIOS,NULL,'I', 'A') as IDOPERACAO,
       MO.DTINIMOVIMENT as DTMESCOMPETENC
  FROM GPE_MOVIMENTACAO MO
  JOIN GPE_VINCULOH VH ON VH.NRORG = MO.NRORG
                      AND VH.NRVINCULOM = MO.NRVINCULOM
                      AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN SST_RELESTRUTRISCO RI ON RI.NRORG = MO.NRORG
                            AND RI.NRESTRUTURAM = MO.NRESTRUTURAM
                            AND RI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                            AND (RI.DTFIMVIGENCIA IS NULL OR RI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC) 
  /*QUERY PARA VERIFICAR SE É INCLUSÃO OU ALTERAÇÃO DO REGISTRO*/
  LEFT JOIN (SELECT EC.NRORG, EC.NRCHAVE, COUNT(*) AS ENVIOS
            FROM ESO_ENVIOCADASTROS EC
            JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                              AND EV.NMEVENTO = 'S-2240'
            /*VERIFICA EMPRESAS DO MESMO GRUPO - CNPJ RAIZ*/
            JOIN ESTRUTURAH EVH ON EVH.NRORG = EC.NRORG
                                AND EVH.NRESTRUTURAM = EC.NRESTRUTURAM
                                AND SUBSTR(REPLACE(REPLACE(REPLACE(EVH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8)
                                AND EVH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                          WHERE H1.NRORG = EVH.NRORG
                                                            AND H1.NRESTRUTURAM = EVH.NRESTRUTURAM
                                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
            WHERE EC.NRORG = :P_NRORG
              AND EC.IDATIVO = 'S' /*QUE ESTIVER ATIVO*/
              AND (EC.IDSTATUS = 'C' OR EC.IDSTATUS = 'A') /*QUE ESTIVER CONCLUIDO*/
              AND EC.NRENVIOEXCL IS NULL /*QUE NAO FOI EXCLUIDO*/
              AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
            GROUP BY EC.NRORG, EC.NRCHAVE) ENV ON ENV.NRCHAVE = MO.NRVINCULOM
 WHERE MO.NRORG = :P_NRORG
   AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
   AND (MO.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (MO.DTINIMOVIMENT >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
UNION ALL
SELECT AO.NRVINCULOM as NRCHAVE,
       AO.NRVINCULOM,
       '' as NRTABELA,
       DECODE(ENV.ENVIOS,NULL,'I', 'A') as IDOPERACAO,
       AO.DTINIOCUPACAO as DTMESCOMPETENC
  FROM GPE_ALTEOCUPACAO AO
  JOIN GPE_VINCULOH VH ON VH.NRORG = AO.NRORG
                      AND VH.NRVINCULOM = AO.NRVINCULOM
                      AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN SST_RELOCUPARISCO RI ON RI.NRORG = AO.NRORG
                            AND RI.NROCUPACAOM = AO.NROCUPACAOM
                            AND RI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                            AND (RI.DTFIMVIGENCIA IS NULL OR RI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC) 
  /*QUERY PARA VERIFICAR SE É INCLUSÃO OU ALTERAÇÃO DO REGISTRO*/
  LEFT JOIN (SELECT EC.NRORG, EC.NRCHAVE, COUNT(*) AS ENVIOS
            FROM ESO_ENVIOCADASTROS EC
            JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                              AND EV.NMEVENTO = 'S-2240'
            /*VERIFICA EMPRESAS DO MESMO GRUPO - CNPJ RAIZ*/
            JOIN ESTRUTURAH EVH ON EVH.NRORG = EC.NRORG
                                AND EVH.NRESTRUTURAM = EC.NRESTRUTURAM
                                AND SUBSTR(REPLACE(REPLACE(REPLACE(EVH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8)
                                AND EVH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                          WHERE H1.NRORG = EVH.NRORG
                                                            AND H1.NRESTRUTURAM = EVH.NRESTRUTURAM
                                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
            WHERE EC.NRORG = :P_NRORG
              AND EC.IDATIVO = 'S' /*QUE ESTIVER ATIVO*/
              AND (EC.IDSTATUS = 'C' OR EC.IDSTATUS = 'A') /*QUE ESTIVER CONCLUIDO*/
              AND EC.NRENVIOEXCL IS NULL /*QUE NAO FOI EXCLUIDO*/
              AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
            GROUP BY EC.NRORG, EC.NRCHAVE) ENV ON ENV.NRCHAVE = AO.NRVINCULOM
 WHERE AO.NRORG = :P_NRORG
   AND AO.DTINIOCUPACAO BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
   AND (AO.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (AO.DTINIOCUPACAO >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
UNION ALL
SELECT RI.NRVINCULOM as NRCHAVE,
       RI.NRVINCULOM,
       '' as NRTABELA,
       DECODE(ENV.ENVIOS,NULL,'I', 'A') as IDOPERACAO,
       TRUNC(RI.DTINIVIGENCIA) as DTMESCOMPETENC
  FROM SST_RELVINCRISCO RI
  JOIN GPE_VINCULOH VH ON VH.NRORG = RI.NRORG
                      AND VH.NRVINCULOM = RI.NRVINCULOM
                      AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*QUERY PARA VERIFICAR SE É INCLUSÃO OU ALTERAÇÃO DO REGISTRO*/
  LEFT JOIN (SELECT EC.NRORG, EC.NRCHAVE, COUNT(*) AS ENVIOS
            FROM ESO_ENVIOCADASTROS EC
            JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                              AND EV.NMEVENTO = 'S-2240'
            /*VERIFICA EMPRESAS DO MESMO GRUPO - CNPJ RAIZ*/
            JOIN ESTRUTURAH EVH ON EVH.NRORG = EC.NRORG
                                AND EVH.NRESTRUTURAM = EC.NRESTRUTURAM
                                AND SUBSTR(REPLACE(REPLACE(REPLACE(EVH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8)
                                AND EVH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                          WHERE H1.NRORG = EVH.NRORG
                                                            AND H1.NRESTRUTURAM = EVH.NRESTRUTURAM
                                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
            WHERE EC.NRORG = :P_NRORG
              AND EC.IDATIVO = 'S' /*QUE ESTIVER ATIVO*/
              AND (EC.IDSTATUS = 'C' OR EC.IDSTATUS = 'A') /*QUE ESTIVER CONCLUIDO*/
              AND EC.NRENVIOEXCL IS NULL /*QUE NAO FOI EXCLUIDO*/
              AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
            GROUP BY EC.NRORG, EC.NRCHAVE) ENV ON ENV.NRCHAVE = RI.NRVINCULOM
 WHERE RI.NRORG = :P_NRORG
   AND RI.DTINIVIGENCIA BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
   AND (RI.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (RI.DTINIVIGENCIA >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
ORDER BY 5,2
";

    $params = array(
      "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
      "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
      "P_CDCNPJEMPREGADOR" => isset($dataset['CDCNPJEMPREGADOR']) ? $dataset['CDCNPJEMPREGADOR'] : null,
      "P_NRESTRUTURAM" => isset($dataset['NRESTRUTURAM']) ? $dataset['NRESTRUTURAM'] : null,
      "P_NRTPAMBIENTE" => isset($dataset['NRTPAMBIENTE']) ? $dataset['NRTPAMBIENTE'] : null,
      "P_NRMOVIMENTACAO" => isset($dataset['NRMOVIMENTACAO']) ? $dataset['NRMOVIMENTACAO'] : null,
      "P_DTREFNAOPERIOD" => isset($dataset['DTREFNAOPERIOD']) ? $dataset['DTREFNAOPERIOD'] : null,
      "P_NRVINCULOM" => isset($params['NRVINCULOM']) ? $params['NRVINCULOM'] : null,
    );

    return $this->connection->fetchAll($sql, $params);
  }
  
  public function getDadosS2240($parametros) {
    try {
        $dataHistorico = \HCM\Util\DateUtil::getDataDeString($parametros['DTMESCOMPETENC'], \HCM\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA, true)->format("d/m/Y");
        
        $getdados2240 =  $this->getDadosOcupacao($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $dataHistorico);
        if($getdados2240 == false){
          $getdados2240 =  $this->getDadosMovimentacao($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $dataHistorico);
  
          if($getdados2240 == false){
            $getdados2240 = $this->getDadosVinculo($parametros['NRENVIO'], $parametros['NRCHAVE'], $parametros['NRESTRUTURAM'], $dataHistorico);
          }
        }
        return $getdados2240;
    } catch(\Exception $e) {
      error_log($e->getMessage());
      throw $e;
    }
  }

  public function getDadosMovimentacao($nrenvio, $nrchave, $nrestruturam, $dthistorico) {
    $sql = "
/*getDadosS2240Movimentacao*/
SELECT VM.NRVINCULOM CHAVE,
      'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) ID,
      DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
      CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
      REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS cpfTrab,
      CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN NULL ELSE NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) END AS MATRICULA,
       CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN CE.CDESOCIAL ELSE '' END CODCATEG,
      TO_CHAR(MO.DTINIMOVIMENT, 'YYYY-MM-DD') AS dtIniCondicao,
      CASE WHEN SUBSTR(PN.NRINSCRICAOPARC, 0,8) = SUBSTR(PAR.NRINSCRICAOPARC,0,8) OR EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTGEREN THEN 1 ELSE 2 END localAmb,
      EH.NMESTRUTURAH AS dscSetor,
      DECODE(DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.CDTIPOINSCRICAO, PN.CDTIPOINSCRICAO),'CNPJ', '1', 'CAEPF', '3', 'CNO', '4', '') infoAmb_tpInsc,
      DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.NRINSCRICAOPARC, PN.NRINSCRICAOPARC) infoAmb_nrInsc,
      SUBSTR(NVL(OH.DSATIVIDADESCARGO, NVL(CBO.DSSUMARIA, NVL(AO.DSOBSERVACAO, MO.DSOBSERVACAO))),0,999) AS dscAtivDes,
      MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, NULL AS NROCUPACAOM, EH.NRPARCREGAMB
  FROM GPE_MOVIMENTACAO MO    
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOM VM ON VM.NRORG = MO.NRORG
                      AND VM.NRVINCULOM = MO.NRVINCULOM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG = VH.NRORG 
                          AND AO.NRVINCULOM = VH.NRVINCULOM 
                          AND AO.DTINIOCUPACAO = (SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                                   WHERE  GPE_ALTEOCUPACAO.NRORG = AO.NRORG 
                                                     AND  GPE_ALTEOCUPACAO.NRVINCULOM = AO.NRVINCULOM 
                                                     AND  GPE_ALTEOCUPACAO.DTINIOCUPACAO <= LAST_DAY(:P_DTMESCOMPETENC))
  JOIN GPE_OCUPACAOH OH ON OH.NRORG = AO.NRORG
                       AND OH.NROCUPACAOM = AO.NROCUPACAOM
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  JOIN GPE_CBO CBO ON CBO.NRCBO = OH.NRCBO
   /*Categoria Trabalhador*/    
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG                           
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE ON PE.NRORG = VM.NRORG
                    AND PE.NRPESSOA = VM.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRPESSOA = PE.NRPESSOA
                     AND PH.NRORG = PE.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PE.NRORG)
  /*Ambiente - Estrutura Movimentada*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)                               
  LEFT JOIN PARCNEGOCIO PN ON PN.NRORG = EH.NRORG
                     AND PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE MO.NRORG = :P_NRORG
   AND MO.NRVINCULOM = :P_NRCHAVE
   AND MO.DTINIMOVIMENT = :P_DTHISTORICO
    ";

    $params = array(
        "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
        "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
        "P_NRENVIO" => $nrenvio,
        "P_NRCHAVE" => $nrchave,
        "P_NRESTRUTURAM" => $nrestruturam,
        "P_DTHISTORICO" => $dthistorico
    );

    return $this->connection->fetchAssoc($sql, $params);
  }
  
 
  public function getDadosOcupacao($nrenvio, $nrchave, $nrestruturam, $dthistorico) {
    $sql = "
/*getDadosS2240Ocupacao*/
SELECT VM.NRVINCULOM CHAVE,
      'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) ID,
      DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
      CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
      REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS cpfTrab,
      CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN NULL ELSE NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) END AS MATRICULA,
       CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN CE.CDESOCIAL ELSE '' END CODCATEG,
      TO_CHAR(AO.DTINIOCUPACAO, 'YYYY-MM-DD') AS dtIniCondicao,
      CASE WHEN SUBSTR(PN.NRINSCRICAOPARC, 0,8) = SUBSTR(PAR.NRINSCRICAOPARC,0,8) OR EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTGEREN THEN 1 ELSE 2 END localAmb,
      EH.NMESTRUTURAH AS dscSetor,
      DECODE(DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.CDTIPOINSCRICAO, PN.CDTIPOINSCRICAO),'CNPJ', '1', 'CAEPF', '3', 'CNO', '4', '') infoAmb_tpInsc,
      DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.NRINSCRICAOPARC, PN.NRINSCRICAOPARC) infoAmb_nrInsc,
      SUBSTR(NVL(OH.DSATIVIDADESCARGO, NVL(CBO.DSSUMARIA, AO.DSOBSERVACAO)),0,999) AS dscAtivDes,
      AO.NRORG, NULL AS NRESTRUTURAM, AO.NRVINCULOM, NULL AS NROCUPACAOM, EH.NRPARCREGAMB
 FROM GPE_ALTEOCUPACAO AO
  JOIN GPE_OCUPACAOH OH ON OH.NRORG = AO.NRORG
                       AND OH.NROCUPACAOM = AO.NROCUPACAOM
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  JOIN GPE_CBO CBO ON CBO.NRCBO = OH.NRCBO
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOM VM ON VM.NRORG = AO.NRORG
                      AND VM.NRVINCULOM = AO.NRVINCULOM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
   /*Categoria Trabalhador*/    
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG                           
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE ON PE.NRORG = VM.NRORG
                    AND PE.NRPESSOA = VM.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRPESSOA = PE.NRPESSOA
                     AND PH.NRORG = PE.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PE.NRORG)
  /*Ambiente - Estrutura Movimentada*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)                               
  LEFT JOIN PARCNEGOCIO PN ON PN.NRORG = EH.NRORG
                     AND PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE AO.NRORG = :P_NRORG
   AND AO.NRVINCULOM = :P_NRCHAVE
   AND AO.DTINIOCUPACAO = :P_DTHISTORICO
    ";

    $params = array(
        "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
        "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
        "P_NRENVIO" => $nrenvio,
        "P_NRCHAVE" => $nrchave,
        "P_NRESTRUTURAM" => $nrestruturam,
        "P_DTHISTORICO" => $dthistorico
    );

    return $this->connection->fetchAssoc($sql, $params);
  }
  
   public function getDadosVinculo($nrenvio, $nrchave, $nrestruturam, $dthistorico) {
    $sql = "
/*getDadosS2240Vinculo*/
SELECT VM.NRVINCULOM CHAVE,
      'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) ID,
      DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
      CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
      REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS cpfTrab,
      CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN NULL ELSE NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) END AS MATRICULA,
       CASE WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN CE.CDESOCIAL ELSE '' END CODCATEG,
      TO_CHAR(RI.DTINIVIGENCIA, 'YYYY-MM-DD') AS dtIniCondicao,
      CASE WHEN SUBSTR(PN.NRINSCRICAOPARC, 0,8) = SUBSTR(PAR.NRINSCRICAOPARC,0,8) OR EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTGEREN THEN 1 ELSE 2 END localAmb,
      EH.NMESTRUTURAH AS dscSetor,
      DECODE(DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.CDTIPOINSCRICAO, PN.CDTIPOINSCRICAO),'CNPJ', '1', 'CAEPF', '3', 'CNO', '4', '') infoAmb_tpInsc,
      DECODE(EM.NRTIPOESTRUTURA, :P_NRTIPOESTRUTGEREN, PAR.NRINSCRICAOPARC, PN.NRINSCRICAOPARC) infoAmb_nrInsc,
      SUBSTR(NVL(OH.DSATIVIDADESCARGO, NVL(CBO.DSSUMARIA, AO.DSOBSERVACAO)),0,999) AS dscAtivDes,
      RI.NRORG, NULL AS NRESTRUTURAM, RI.NRVINCULOM, NULL AS NROCUPACAOM, EH.NRPARCREGAMB
  FROM SST_RELVINCRISCO RI
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOM VM ON VM.NRORG = RI.NRORG
                      AND VM.NRVINCULOM = RI.NRVINCULOM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG = VH.NRORG 
                          AND AO.NRVINCULOM = VH.NRVINCULOM 
                          AND AO.DTINIOCUPACAO = (SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                                   WHERE  GPE_ALTEOCUPACAO.NRORG = AO.NRORG 
                                                     AND  GPE_ALTEOCUPACAO.NRVINCULOM = AO.NRVINCULOM 
                                                     AND  GPE_ALTEOCUPACAO.DTINIOCUPACAO <= LAST_DAY(:P_DTMESCOMPETENC))
  JOIN GPE_OCUPACAOH OH ON OH.NRORG = AO.NRORG
                       AND OH.NROCUPACAOM = AO.NROCUPACAOM
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  JOIN GPE_CBO CBO ON CBO.NRCBO = OH.NRCBO
   /*Categoria Trabalhador*/    
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG                           
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE ON PE.NRORG = VM.NRORG
                    AND PE.NRPESSOA = VM.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRPESSOA = PE.NRPESSOA
                     AND PH.NRORG = PE.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PE.NRORG)
  /*Ambiente - Estrutura Movimentada*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)                               
  LEFT JOIN PARCNEGOCIO PN ON PN.NRORG = EH.NRORG
                     AND PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE RI.NRORG = :P_NRORG
   AND RI.NRVINCULOM = :P_NRCHAVE
   AND TRUNC(RI.DTINIVIGENCIA) = :P_DTHISTORICO
    ";

    $params = array(
        "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
        "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
        "P_NRENVIO" => $nrenvio,
        "P_NRCHAVE" => $nrchave,
        "P_NRESTRUTURAM" => $nrestruturam,
        "P_DTHISTORICO" => $dthistorico
    );

    return $this->connection->fetchAssoc($sql, $params);
  }

  public function getDadosS2240agNoc($parametros) {
    try {
        return $this->getDadosAgNoc($parametros['NRORG'], $parametros['NRESTRUTURAM'], $parametros['NRCARGO'], $parametros['NRFUNCAO'], $parametros['NRVINCULOM']);
    } catch(\Exception $e) {
      error_log($e->getMessage());
      throw $e;
    }
  }

  public function getDadosAgNoc($nrorg, $nrestruturam, $nrcargo, $nrfuncao, $nrvinculo) {
    $sql = "
SELECT DISTINCT
    DECODE(codAgNoc,'09.01.001',NULL,tpAval) tpAval,
    codAgNoc,
    dscAgNoc,
    DECODE(codAgNoc,'09.01.001',NULL,utilizEPC) utilizEPC,
    DECODE(codAgNoc,'09.01.001',NULL,utilizEPI) utilizEPI
  FROM (
  
    SELECT
      2 tpAval,
      AGNOC.CDESOCIAL codAgNoc,
      AGNOC.DSAGENTENOCIVO dscAgNoc,
      DECODE(RC.NRRISCOEPC, NULL, 1, 2) utilizEPC,
      DECODE(RE.NRRISCOEPI, NULL, 1, 2) utilizEPI
    FROM SST_RELESTRUTRISCO RER
    JOIN SST_FATORRISCO FR ON FR.NRFATORRISCO = RER.NRFATORRISCO
                        AND FR.NRORG = RER.NRORG
    LEFT JOIN SST_RISCOEPI RE ON RE.NRFATORRISCO = FR.NRFATORRISCO
                          AND RE.NRORG = FR.NRORG 
    LEFT JOIN SST_RISCOEPC RC ON RC.NRFATORRISCO = FR.NRFATORRISCO
                          AND RC.NRORG = FR.NRORG
    JOIN ESO_AGENTENOCIVO AGNOC ON AGNOC.NRAGENTENOCIVO = FR.NRAGENTENOCIVO
                               AND (AGNOC.NRORG = FR.NRORG OR AGNOC.NRORG = 0)
    WHERE RER.NRORG = :P_NRORG
    AND RER.NRESTRUTURAM = :P_NRESTRUTURAM

UNION ALL 

  SELECT
      2 tpAval,
      AGNOC.CDESOCIAL codAgNoc,
      AGNOC.DSAGENTENOCIVO dscAgNoc,
      DECODE(RC.NRRISCOEPC, NULL, 1, 2) utilizEPC,
      DECODE(RE.NRRISCOEPI, NULL, 1, 2) utilizEPI
    FROM SST_RELOCUPARISCO RTR
    JOIN SST_FATORRISCO FR ON FR.NRFATORRISCO = RTR.NRFATORRISCO
                        AND FR.NRORG = RTR.NRORG
    LEFT JOIN SST_RISCOEPI RE ON RE.NRFATORRISCO = FR.NRFATORRISCO
                          AND RE.NRORG = FR.NRORG 
    LEFT JOIN SST_RISCOEPC RC ON RC.NRFATORRISCO = FR.NRFATORRISCO
                          AND RC.NRORG = FR.NRORG
    JOIN ESO_AGENTENOCIVO AGNOC ON AGNOC.NRAGENTENOCIVO = FR.NRAGENTENOCIVO
                               AND (AGNOC.NRORG = FR.NRORG OR AGNOC.NRORG = 0)
    WHERE RTR.NRORG = :P_NRORG
    AND (RTR.NROCUPACAOM = :P_NRFUNCAO OR RTR.NROCUPACAOM = :P_NRCARGO)
    
UNION ALL 

  SELECT
      2 tpAval,
      AGNOC.CDESOCIAL codAgNoc,
      AGNOC.DSAGENTENOCIVO dscAgNoc,
      DECODE(RC.NRRISCOEPC, NULL, 1, 2) utilizEPC,
      DECODE(RE.NRRISCOEPI, NULL, 1, 2) utilizEPI
    FROM SST_RELVINCRISCO REV
    JOIN SST_FATORRISCO FR ON FR.NRFATORRISCO = REV.NRFATORRISCO
                        AND FR.NRORG = REV.NRORG
    LEFT JOIN SST_RISCOEPI RE ON RE.NRFATORRISCO = FR.NRFATORRISCO
                          AND RE.NRORG = FR.NRORG 
    LEFT JOIN SST_RISCOEPC RC ON RC.NRFATORRISCO = FR.NRFATORRISCO
                          AND RC.NRORG = FR.NRORG
    JOIN ESO_AGENTENOCIVO AGNOC ON AGNOC.NRAGENTENOCIVO = FR.NRAGENTENOCIVO
                               AND (AGNOC.NRORG = FR.NRORG OR AGNOC.NRORG = 0)
    WHERE REV.NRORG = :P_NRORG
    AND REV.NRVINCULOM = :P_NRVINCULOM
    
  )
    ";
    $params = array(
        "P_NRORG" => $nrorg,
        "P_NRESTRUTURAM" => $nrestruturam,
        "P_NRCARGO" => $nrcargo,
        "P_NRFUNCAO" => $nrfuncao,
        "P_NRVINCULOM" => $nrvinculo
    );
    return $this->connection->fetchAll($sql, $params);
  }

  public function getDadosS2240respReg($parametros) {
    try {
        return $this->getDadosRespReg($parametros['NRORG'], $parametros['NRPARCREGAMB']);
    } catch(\Exception $e) {
      error_log($e->getMessage());
      throw $e;
    }
  }
  public function getDadosRespReg($nrorg, $nrparcregamb) {
    $sql = "
      SELECT  DECODE(PHAMB.NRCONSELHOREG, 3, 1, 4, 4, 9) AS ideOC,
        PHAMB.NRINSCRCONSREG AS nrOc,
        PHAMB.SGUFCONSREG AS ufOC,
        REPLACE(REPLACE(PHAMB.NRCPFPESSOA,'.'),'-') cpfResp
      FROM PARCNEGOCIO PARAMB 
      LEFT JOIN GPE_PESSOA PAMB ON PAMB.NRPARCNEGOCIO = PARAMB.NRPARCNEGOCIO
                              AND PAMB.NRORG = PARAMB.NRORG
      LEFT JOIN GPE_PESSOAH PHAMB ON PHAMB.NRPESSOA = PAMB.NRPESSOA
                                AND PHAMB.NRORG = PAMB.NRORG
                                AND PHAMB.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                              WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                AND GPE_PESSOAH.NRPESSOA = PHAMB.NRPESSOA
                                                                AND GPE_PESSOAH.NRORG = PHAMB.NRORG)
    WHERE PARAMB.NRORG = :P_NRORG
    AND PARAMB.NRPARCNEGOCIO = :P_NRPARCREGAMB
    ";
    $params = array(
        "P_NRORG" => $nrorg,
        "P_NRPARCREGAMB" => $nrparcregamb,
        "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia()
    );
    return $this->connection->fetchAll($sql, $params);
  }
}