<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Gestaopessoas\Entities\SstRelestrutrisco;
use HCM\Util\DateUtil;
use Geral\Util\NovoCodigo;
use HCM\Util\Repositories;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\FPA\Entity\FpaeventoctblEntity;

class RelestrutriscoService {

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_evento_contabil = new FpaeventoctblEntity($entityManager, $hcmParameters);
    }

    public function cadAutFatorRiscoPorEstrutura($nrEstrutura, $nrFatorRisco, $row) {

        $codigo = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'SST_RELESTRUTRISCO', 1, 12, true);
        $obj = new SstRelestrutrisco;
        $obj->setNrrelestrutrisco($codigo);
        $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtinclusao(DateUtil::getDataAtual());
        $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtultatu(DateUtil::getDataAtual());
        $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
        $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $obj->setNrestruturam($nrEstrutura);
        $obj->setNrfatorrisco($nrFatorRisco);
        $obj->setDtinivigencia(DateUtil::getDataDeString($row['DTINIVIGENCIA'], DateUtil::FORMATO_BRASILEIRO, true));
        $obj->setDtfimvigencia(isset($row['DTFIMVIGENCIA']) ? DateUtil::getDataDeString($row['DTFIMVIGENCIA'], DateUtil::FORMATO_BRASILEIRO, true) : null);
        $obj->setIdativo($row['IDATIVO']);

        $this->entityManager->persist($obj);
        $this->entityManager->flush($obj);        
    }
    
    public function getRelEstrutRiscoCad($nrorg, $nrEstrutura, $nrFatorRisco){
        return $this->entityManager->getRepository(Repositories::SST_RELESTRUTRISCO)->findOneBy(array('nrorg' => $nrorg, 'nrestruturam' => $nrEstrutura, 'nrfatorrisco' => $nrFatorRisco));
        
    }
    
} 