/* SELECTS DOS INTERVALOS (INTRAJORNADA/INTERJORNADA) E TOTALIZADORES (ABONO, FALTA, EXTRA, IMPAR, ATRASO) */
WITH

VINCULOS AS (
    SELECT
        VM.NRORG,
        VM.NRVINCULOM,
        VM.NMVINCULOM,
        VM.NMVINCULOM || ', PIS: ' || NVL(PH.NRPISPASEPPES, 'Não encontrado') AS NMVINCULOM_NOTGROUPED,
        VM.NRTIPOVINCULOM,
        VH.NRESTRUTGEREN,
        VH.NRESTRUTLEGAL,
        TH.NMTIPOVINCULOH,
        PH.NRPISPASEPPES,
        AE.NRSITUFUNCM,
        SFH.NMSITUFUNCH,
        PA.NRPERIODOAPURACAO,
        PA.DTINICIALAPURACAO,
        PA.DTFINALAPURACAO
    FROM
        GPE_VINCULOM VM
        JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
            AND VH.NRORG = VM.NRORG
            AND VH.DTMESCOMPETENC IN (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_VINCULOH VIH
            WHERE
                VIH.NRVINCULOM = VH.NRVINCULOM
                AND VIH.NRORG = VH.NRORG
                AND TO_CHAR(VIH.DTMESCOMPETENC, 'DD/MM/YYYY') <= :P_DTMESCOMPETENC
        )
        LEFT JOIN GPE_PESSOAH PH ON PH.NRORG = VM.NRORG
            AND PH.NRPESSOA = VM.NRPESSOA
            AND PH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_PESSOAH
            WHERE
                NRORG = PH.NRORG
                AND NRPESSOA = PH.NRPESSOA
                AND DTMESCOMPETENC < LAST_DAY(:P_DTMESCOMPETENC)
        )
        LEFT JOIN GPE_TIPOVINCULOH TH ON ( TH.NRORG = VM.NRORG OR TH.NRORG = :P_NRORG_PADRAO )
            AND TH.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
            AND TH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_TIPOVINCULOH
            WHERE
                NRORG = TH.NRORG
                AND NRTIPOVINCULOM = TH.NRTIPOVINCULOM
                AND DTMESCOMPETENC < LAST_DAY(:P_DTMESCOMPETENC)
        )
        LEFT JOIN GPE_ALTESITUFUNC AE ON AE.NRVINCULOM = VM.NRVINCULOM
            AND AE.NRORG = VM.NRORG
            AND AE.NRSITUFUNCM <> 12
            AND AE.DTINISITUFUNC = (
            SELECT
                MAX(DTINISITUFUNC)
            FROM
                GPE_ALTESITUFUNC
            WHERE
                NRVINCULOM = AE.NRVINCULOM
                AND NRORG = AE.NRORG
                AND NRSITUFUNCM <> 12
                AND DTINISITUFUNC <= LAST_DAY(:P_DTMESCOMPETENC)
        )
        LEFT JOIN GPE_SITUFUNCH SFH ON SFH.NRSITUFUNCM = AE.NRSITUFUNCM
            AND ( SFH.NRORG = VM.NRORG OR SFH.NRORG = :P_NRORG_PADRAO OR SFH.NRORG IS NULL )
            AND SFH.DTEFETIVA = (
            SELECT
                MAX(DTEFETIVA)
            FROM
                GPE_SITUFUNCH
            WHERE
                NRSITUFUNCM = SFH.NRSITUFUNCM
                AND DTEFETIVA <= :P_DTMESCOMPETENC
        )
        LEFT JOIN PTO_PERIODOAPURACAO   PA ON PA.NRORG = VM.NRORG
                                            AND PA.NRPERIODOAPURACAO = :NRPERIODOAPURACAO
    WHERE
        VM.NRORG = :P_NRORG
        /* FILTROS DE VINCULOS */
        AND ( VM.DTRESCISAOVINC IS NULL
              OR VM.DTRESCISAOVINC > LAST_DAY(PA.DTFINALAPURACAO) )
        AND ( INSTR(:NRVINCULOM_LIST, ','
                                      || VM.NRVINCULOM
                                      || ',') > 0
              OR :NRVINCULOM_LIST IS NULL )
        AND ( INSTR(:NRESTRUTLEGAL_LIST, ','
                                         || VH.NRESTRUTLEGAL
                                         || ',') > 0
              OR :NRESTRUTLEGAL_LIST IS NULL )
        AND ( INSTR(:NRESTRUTGEREN_LIST, ','
                                         || VH.NRESTRUTGEREN
                                         || ',') > 0
              OR :NRESTRUTGEREN_LIST IS NULL )
        AND ( INSTR(:NRTIPOVINCULOM_LIST, ','
                                         || VM.NRTIPOVINCULOM
                                         || ',') > 0
              OR :NRTIPOVINCULOM_LIST IS NULL )
        AND ( INSTR(:NRSITUFUNCM_LIST, ','
                                         || AE.NRSITUFUNCM
                                         || ',') > 0
              OR :NRSITUFUNCM_LIST IS NULL )
),

DIAS_OCORRENCIA AS (
    SELECT
        VINCULOS.NRVINCULOM,
        PO.NRPROGOCORRENCIA,
        PO.NRTIPOPROGOCORRENCIA,
        PO.NRMOTIVOOCORFREQ,
        MO.DSMOTIVOOCORFREQ,
        DT.DTDATA,
        PO.DTINICIOPROGOCOR,
        PO.DTFIMPROGOCOR,
        PO.IDDIASSEMANA,
        PO.IDTIPODIACALENDARIO,
        PO.IDTIPOHORARIO,
        PO.NRHORDIAM,
        PO.DSOBSERVACAO,
        PO.NRMARCACAOPONTO
    FROM VINCULOS
    JOIN DATA DT ON DT.DTDATA BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
    JOIN PTO_PROGOCORRENCIA PO ON PO.NRORG = VINCULOS.NRORG
        AND PO.NRVINCULOM = VINCULOS.NRVINCULOM
        AND DT.DTDATA BETWEEN PO.DTINICIOPROGOCOR AND NVL(PO.DTFIMPROGOCOR, DT.DTDATA)
        AND PO.IDATIVO = 'S'
        AND PO.IDPROGOCORCONFIRMADA = 'S'
        AND SUBSTR(PO.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
    LEFT JOIN PTO_MOTIVOOCORFREQ MO ON MO.NRORG = VINCULOS.NRORG
        AND MO.NRMOTIVOOCORFREQ = PO.NRMOTIVOOCORFREQ
),

BATIDAS_DIA AS (
    SELECT
        VINCULOS.*,
        MARC.DTHRAJUSTADA,
        MARC.IDDIAOCORRENCIA,
        MARC.NRMARCACAOPONTO,
        CASE
            WHEN MARC.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
                TRUNC(DTHRAJUSTADA) - 1
            WHEN MARC.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
                TRUNC(DTHRAJUSTADA) + 1
            ELSE
                TRUNC(DTHRAJUSTADA)
        END DATA_APURACAO
    FROM
        VINCULOS
        JOIN GPE_MARCACAOPONTO MARC ON MARC.NRORG = VINCULOS.NRORG
            AND MARC.NRVINCULOM = VINCULOS.NRVINCULOM
            AND (
                ( MARC.NRCOLETOR NOT IN (
                    SELECT NRCOLETOR
                    FROM GPE_PARAMORG
                    UNPIVOT (NRCOLETOR FOR NRCOLETOR_TIPO IN (NRCOLETORMARCGERSIST, NRCOLETORMARCVIRADIA, NRCOLETORMARCPROJETADA ))
                    WHERE NRORG = VINCULOS.NRORG
                ) AND :NRCOLETOR_LIST IS NULL ) OR
                INSTR(:NRCOLETOR_LIST, ',' || MARC.NRCOLETOR || ',') > 0
            ) AND (
                CASE
                    WHEN MARC.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
                        TRUNC(MARC.DTHRAJUSTADA) - 1
                    WHEN MARC.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
                        TRUNC(MARC.DTHRAJUSTADA) + 1
                    ELSE
                        TRUNC(MARC.DTHRAJUSTADA)
                END
            ) BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
    ORDER BY
        VINCULOS.NMVINCULOM,
        MARC.DTHRAJUSTADA
),

TOTALIZADORES AS ( /* SELECT QUE BUSCA AS TOTALIZACOES, POR DIA, DE ABONO, FALTA, EXTRA, IMPAR E ATRASO */
    SELECT
        VINCULOS.*,
        DT.DTDATA,
        /* OCORRENCIA DE ABONO EXISTENTE */
        CASE
            WHEN OC_ABONA_FALTA.NRPROGOCORRENCIA IS NOT NULL /*THEN NVL(MO.DSMOTIVOOCORFREQ, 'Falta abonada')*/ THEN
                DECODE(OC_ABONA_FALTA.NRMOTIVOOCORFREQ, 22, 'AB_FERI - Férias', 5, 'AB_ATME - Atestado Médico', 14, 'AB_INSS - Afastado INSS', 15, 'AB_LMAT - Licença Maternidade', 'Falta abonada')
            ELSE
                NULL
        END ABONO,
        /* TROCA DE HORARIO */
        CASE
            WHEN OC_TROCA_HORARIO.NRPROGOCORRENCIA IS NOT NULL THEN
                'AB_TROC - Troca de Horário (' || HH.NMHORDIAH || ')'
            ELSE
                NULL
        END TROCA,
        /* SITUACOES DE FALTA E ATRASO */
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND NVL(CALCULO_INTERVALOS.VALOR, 0) = 0
                 AND OC_ABONA_FALTA.NRPROGOCORRENCIA IS NULL THEN
                'Falta injustificada'
            ELSE
                NULL
        END FALTA,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL
                 AND OC_ABONA_FALTA.NRPROGOCORRENCIA IS NULL THEN
                'Atraso injustificado'
            ELSE
                NULL
        END ATRASO,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL
                 AND OC_ABONA_FALTA.NRPROGOCORRENCIA IS NULL THEN
                TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR
            ELSE
                NULL
        END VALOR_ATRASO_HOURS,
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F'
                 AND CALCULO_INTERVALOS.VALOR < TEMPO_JORNADA.VALOR
                 AND OC_ABONO_SAIDA.NRPROGOCORRENCIA IS NULL
                 AND OC_ABONA_FALTA.NRPROGOCORRENCIA IS NULL THEN
                LPAD(TRUNC(TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR), 2, '0') || ':' || LPAD(ROUND((((TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR) - TRUNC(TEMPO_JORNADA.VALOR - CALCULO_INTERVALOS.VALOR)) * 60)), 2, '0')
            ELSE
                NULL
        END VALOR_ATRASO_TIME,
        /* EXISTENCIA DE TEMPO ALEM DA JORANADA */
        CASE
            WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
                 OR ( HH.IDTIPOHORARIO = 'F'
                      AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
                CASE
            WHEN :P_VALOR IS NOT NULL
                 AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
                'Tempo extra realizado SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
            WHEN :P_VALOR IS NOT NULL
                 AND :P_CONDICAO = 'MENOR_IGUAL' THEN
                'Tempo extra realizado INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
            ELSE
                'Tempo extra realizado'
            END ELSE NULL
        END EXTRA,
        CASE
            WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
                 OR ( HH.IDTIPOHORARIO = 'F'
                      AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
                CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR
            ELSE
                NULL
        END VALOR_EXTRA_HOURS,
        CASE
            WHEN CALCULO_INTERVALOS.VALOR > TEMPO_JORNADA.VALOR
                 OR ( HH.IDTIPOHORARIO = 'F'
                      AND CALCULO_INTERVALOS.VALOR > 0 ) THEN
                LPAD(TRUNC(CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR), 2, '0') || ':' || LPAD(ROUND((((CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR) - TRUNC(CALCULO_INTERVALOS.VALOR - TEMPO_JORNADA.VALOR)) * 60)), 2, '0')
            ELSE
                NULL
        END VALOR_EXTRA_TIME,
        /* QUANTIDADE IMPAR DE MARCACOES NO DIA */
        CASE
            WHEN MOD(NVL(QTD_MARCACOES.VALOR, 0), 2) <> 0 THEN
                'Quantidade ímpar de marcações'
            ELSE
                NULL
        END QTD_MARCACOES_IMPAR,
        /* QUANTIDADE DE BATIDAS INFERIOR AO PREVISTO NO HORARIO DO DIA */
        CASE
            WHEN HH.IDTIPOHORARIO <> 'F' AND NVL(QTD_MARCACOES.VALOR, 0) > NVL(QTD_MARCACOES_HORARIO.VALOR, 0) THEN
                'Quantidade de marcações ('  || NVL(QTD_MARCACOES.VALOR, 0) || ') SUPERIOR ao previsto'
            ELSE
                NULL
        END QTD_MARCACOES_MAIOR,
        /* QUANTIDADE DE BATIDAS INFERIOR AO PREVISTO NO HORARIO DO DIA */
        CASE
            WHEN NVL(QTD_MARCACOES.VALOR, 0) < NVL(QTD_MARCACOES_HORARIO.VALOR, 0) THEN
                'Quantidade de marcações (' || NVL(QTD_MARCACOES.VALOR, 0) || ') INFERIOR ao previsto'
            ELSE
                NULL
        END QTD_MARCACOES_MENOR
    FROM
        VINCULOS
        JOIN DATA DT ON DT.DTDATA BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
        
        /* OCORRENCIAS DE FREQUENCIA */
        LEFT JOIN PTO_PROGOCORRENCIA OC_ABONA_FALTA ON OC_ABONA_FALTA.NRORG = VINCULOS.NRORG
            AND OC_ABONA_FALTA.NRVINCULOM = VINCULOS.NRVINCULOM
            AND DT.DTDATA BETWEEN OC_ABONA_FALTA.DTINICIOPROGOCOR AND NVL(OC_ABONA_FALTA.DTFIMPROGOCOR, DT.DTDATA)
            AND OC_ABONA_FALTA.IDATIVO = 'S'
            AND OC_ABONA_FALTA.NRTIPOPROGOCORRENCIA = 5
            AND SUBSTR(OC_ABONA_FALTA.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
        LEFT JOIN PTO_PROGOCORRENCIA    OC_ABONO_SAIDA ON OC_ABONO_SAIDA.NRORG = VINCULOS.NRORG
            AND OC_ABONO_SAIDA.NRVINCULOM = VINCULOS.NRVINCULOM
            AND DT.DTDATA BETWEEN OC_ABONO_SAIDA.DTINICIOPROGOCOR AND NVL(OC_ABONO_SAIDA.DTFIMPROGOCOR, DT.DTDATA)
            AND OC_ABONO_SAIDA.IDATIVO = 'S'
            AND OC_ABONO_SAIDA.NRTIPOPROGOCORRENCIA IN (4, 16, 17, 23)
            AND SUBSTR(OC_ABONO_SAIDA.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
        LEFT JOIN PTO_PROGOCORRENCIA    OC_TROCA_HORARIO ON OC_TROCA_HORARIO.NRORG = VINCULOS.NRORG
            AND OC_TROCA_HORARIO.NRVINCULOM = VINCULOS.NRVINCULOM
            AND DT.DTDATA BETWEEN OC_TROCA_HORARIO.DTINICIOPROGOCOR AND NVL(OC_TROCA_HORARIO.DTFIMPROGOCOR, DT.DTDATA)
            AND OC_TROCA_HORARIO.IDATIVO = 'S'
            AND OC_TROCA_HORARIO.NRTIPOPROGOCORRENCIA = 29
            AND SUBSTR(OC_TROCA_HORARIO.IDDIASSEMANA, TO_CHAR(DT.DTDATA, 'D'), 1) = '1'
                                                         
        /* ALTERACAO DE ESCALA MAIS RECENTE PARA O DIA */
        LEFT JOIN GPE_ALTEESCALA AE ON AE.NRORG = VINCULOS.NRORG
            AND AE.NRVINCULOM = VINCULOS.NRVINCULOM
            AND AE.NRTURNO IS NOT NULL
            AND AE.DTINIESCALA = (
            SELECT
                MAX(DTINIESCALA)
            FROM
                GPE_ALTEESCALA
            WHERE
                NRORG = AE.NRORG
                AND NRVINCULOM = AE.NRVINCULOM
                AND DT.DTDATA BETWEEN DTINIESCALA AND NVL(DTFIMESCALA, DT.DTDATA)
        )
        LEFT JOIN GPE_TURNO T ON T.NRORG = VINCULOS.NRORG
            AND T.NRTURNO = AE.NRTURNO
                                 
        /* HORARIO DO DIA */
        LEFT JOIN GPE_HORARIOTURNO HT ON HT.NRORG = VINCULOS.NRORG
            AND HT.NRTURNO = AE.NRTURNO
            AND NRSEQHORARIO = (/* BUSCA ENTRE OS HORARIOS DO TURNO QUAL E O HORARIO DO DIA EM QUESTAO */
            SELECT
                MOD((DT.DTDATA - TRUNC(T.DTDATABASE)), COUNT(*)) + 1
            FROM
                GPE_HORARIOTURNO
            WHERE
                NRORG = HT.NRORG
                AND NRTURNO = HT.NRTURNO
        )
        
        /* QUANTIDADE DE HORARIOS DO DIA */
        LEFT JOIN (
            SELECT
                NRORG,
                NRHORDIAM,
                COUNT(*) AS VALOR
            FROM GPE_INTERVALOSHORARIO
            UNPIVOT (MARCACAO FOR ENTR_SAIDA IN (HRENTRADA, HRSAIDA))
            WHERE NRORG = :P_NRORG
            GROUP BY
                NRORG,
                NRHORDIAM
        ) QTD_MARCACOES_HORARIO ON QTD_MARCACOES_HORARIO.NRHORDIAM = HT.NRHORDIAM
        
        /* DADOS DO HORARIO DO DIA */
        LEFT JOIN GPE_HORDIAH HH ON HH.NRORG = VINCULOS.NRORG
            AND HH.NRHORDIAM = NVL(OC_TROCA_HORARIO.NRHORDIAM, HT.NRHORDIAM)
            AND HH.DTMESCOMPETENC = (
            SELECT
                MAX(DTMESCOMPETENC)
            FROM
                GPE_HORDIAH
            WHERE
                NRORG = HH.NRORG
                AND NRHORDIAM = HH.NRHORDIAM
                AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        )
        
        /* SOMA O TEMPO DOS INTERVALOS DO HORARIO */
        LEFT JOIN (
            SELECT
                HM.NRORG,
                HM.NRHORDIAM,
                NVL(SUM(
                    (ROUND(TO_NUMBER(SUBSTR(IH.HRSAIDA, 0, 2)) + (TO_NUMBER(SUBSTR(IH.HRSAIDA, 3, 4)) / 60), 5)) - (ROUND(TO_NUMBER(SUBSTR(IH.HRENTRADA, 0, 2)) + (TO_NUMBER(SUBSTR(IH.HRENTRADA, 3, 4)) / 60), 5))
                    + (
                        /* CONSIDERA SITUACOES DE VIRADA DE DIA NO CALCULO */
                        CASE
                            WHEN SUBSTR(IH.IDDIAOCORREENTRADA, 2, 1) <> SUBSTR(IH.IDDIAOCORRESAIDA, 2, 1) THEN 24
                            ELSE 0
                        END
                    )
                ), 0) AS VALOR
            FROM
                GPE_HORDIAM             HM
                LEFT JOIN GPE_INTERVALOSHORARIO   IH ON IH.NRORG = HM.NRORG
                                                      AND IH.NRHORDIAM = HM.NRHORDIAM
            WHERE
                HM.NRORG = :P_NRORG
            GROUP BY
                HM.NRORG,
                HM.NRHORDIAM
        ) TEMPO_JORNADA ON TEMPO_JORNADA.NRHORDIAM = HH.NRHORDIAM
        
        /* SOMA O TEMPO DOS INTERVALOS DAS BATIDAS DE PONTO */
        LEFT JOIN (
            SELECT
                INTERVALOS_TRABALHO.NRORG,
                INTERVALOS_TRABALHO.NRVINCULOM,
                INTERVALOS_TRABALHO.DATA_APURACAO,
                SUM(ROUND(((INTERVALOS_TRABALHO.DTHRAJUSTADA_FIM - INTERVALOS_TRABALHO.DTHRAJUSTADA) * 24), 5)) VALOR
            FROM
                (
                    SELECT
                        MARCACOES_SEQUENCIADAS.*
                    FROM
                        (
                            SELECT
                                ROW_NUMBER() OVER(
                                    PARTITION BY NRORG, NRVINCULOM, DATA_APURACAO
                                    ORDER BY
                                        DTHRAJUSTADA
                                ) AS SEQUENCIA_INTERVALO,
                                BATIDAS_DIA.*,
                                LEAD(DTHRAJUSTADA, 1, TO_DATE('01/01/0001')) OVER(
                                    PARTITION BY NRORG, NRVINCULOM, DATA_APURACAO
                                    ORDER BY
                                        NRORG, NRVINCULOM, DATA_APURACAO
                                ) DTHRAJUSTADA_FIM
                            FROM BATIDAS_DIA
                        ) MARCACOES_SEQUENCIADAS
                    WHERE
                        DTHRAJUSTADA_FIM <> '01/01/0001'
                        AND MOD(SEQUENCIA_INTERVALO, 2) <> 0
                ) INTERVALOS_TRABALHO
            GROUP BY
                NRORG,
                NRVINCULOM,
                DATA_APURACAO
        ) CALCULO_INTERVALOS ON CALCULO_INTERVALOS.NRVINCULOM = VINCULOS.NRVINCULOM
                                AND CALCULO_INTERVALOS.DATA_APURACAO = DT.DTDATA
                                
        /* QUANTIDADE DE MARCACOES */
        LEFT JOIN (
            SELECT
                NRORG,
                NRVINCULOM,
                DATA_APURACAO,
                COUNT(*) AS VALOR
            FROM BATIDAS_DIA
            GROUP BY
                NRORG,
                NRVINCULOM,
                DATA_APURACAO
        ) QTD_MARCACOES ON QTD_MARCACOES.NRVINCULOM = VINCULOS.NRVINCULOM
                               AND QTD_MARCACOES.DATA_APURACAO = DT.DTDATA
),

TOTALIZADORES_POS AS ( /* PROCESSAMENTO DE TOTALIZADORES DEPENDENTES DOS TOTALIZADORES INICIAIS. JOINS DEVEM SER EVITADOS PARA QUE O RESULTADO BASE DOS TOTALIZADORES NAO SEJA ALTERADO */
    SELECT
        TOTALIZADORES.*,
        
        /* TIPOS ESPECIFICOS QUE SERAO CONDICIONADOS A PARTIR DOS TOTALIZADORES INICIAIS */
        CASE
            WHEN QTD_MARCACOES_MENOR IS NOT NULL
                AND OC_COMP_ABONO.DTDATA IS NULL
            THEN
                QTD_MARCACOES_MENOR || ' [Possível diferença não compensada/abonada]'
            ELSE NULL
        END AS QTMENOR_COMP,
        CASE
            WHEN QTD_MARCACOES_MAIOR IS NOT NULL
                AND OC_COMP_ABONO.DTDATA IS NULL
            THEN
                QTD_MARCACOES_MAIOR || ' [Possível diferença não compensada/abonada]'
            ELSE NULL
        END AS QTMAIOR_COMP
    FROM TOTALIZADORES
    LEFT JOIN (
        SELECT
            NRVINCULOM,
            DTDATA
        FROM DIAS_OCORRENCIA
        WHERE NRTIPOPROGOCORRENCIA IN (2, 27, 4, 16, 17, 23, 5, 15) /* TIPOS PROPRIOS PARA ABONO/COMPENSACAO OU REGISTRAR SITUACAO */
        GROUP BY NRVINCULOM, DTDATA
    ) OC_COMP_ABONO ON OC_COMP_ABONO.NRVINCULOM = TOTALIZADORES.NRVINCULOM
        AND OC_COMP_ABONO.DTDATA = TOTALIZADORES.DTDATA
),

INTERVALOS AS (
    /* SELECT QUE BUSCA OS INTERVALOS DAS BATIDAS (DUAS A DUAS) IDENTIFICANDO OCORRENCIAS */
    SELECT
        INTERVALOS_PROCESSADOS.*,
    CASE
        WHEN INTERVALOS_PROCESSADOS.TIPO_OCORRENCIA = 'INTERJORNADA' THEN
            CASE
                WHEN INTERVALOS_PROCESSADOS.HRTEMPODESCANSODIARIO > INTERVALOS_PROCESSADOS.DIFF_HOURS THEN
                    'O Funcionário cumpriu um intervalo INFERIOR ao configurado entre jornadas dentre os parâmetros da organização'
                WHEN :P_VALOR IS NOT NULL
                     AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo entre jornadas SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                WHEN :P_VALOR IS NOT NULL
                     AND :P_CONDICAO = 'MENOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo entre jornadas INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                    END
        WHEN INTERVALOS_PROCESSADOS.TIPO_OCORRENCIA = 'INTRAJORNADA' THEN
            CASE
                WHEN INTERVALOS_PROCESSADOS.TEMPO_ALMOCO_HORARIO > INTERVALOS_PROCESSADOS.DIFF_HOURS THEN
                    'O Funcionário cumpriu um intervalo INFERIOR ao configurado em seu horário de trabalho'
                WHEN :P_VALOR IS NOT NULL AND :P_CONDICAO = 'MAIOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo de descanso SUPERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
                WHEN :P_VALOR IS NOT NULL AND :P_CONDICAO = 'MENOR_IGUAL' THEN
                    'O Funcionário cumpriu um intervalo de descanso INFERIOR ou IGUAL ao limite informado (' || :P_VALOR || ')'
            END
        ELSE NULL
    END OBSERVACAO
    FROM
        ( /* SELECT QUE SOMA E ANALISA INTERVALOS */
            SELECT
                INTERVALOS.*,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'HH24:MI') AS HORA_INICIO,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'DD/MM/YYYY') AS DATA_INICIO,
                TO_CHAR(INTERVALOS.HORARIO_INICIO, 'YYYY-MM-DD') AS DATA_INICIO_FILTER,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'HH24:MI') AS HORA_FIM,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') AS DATA_FIM,
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'YYYY-MM-DD') AS DATA_FIM_FILTER,
                ROUND((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24, 5) AS DIFF_HOURS,
                LPAD(TRUNC(((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24)), 2, '0') || ':' || LPAD(ROUND(((((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24) - TRUNC(((INTERVALOS.HORARIO_FIM - HORARIO_INICIO) * 24))) * 60)), 2, '0') DIFF_TIME,
                /* DETERMINA SE O INTERVALO EH INTERJORNADA, INTRAJORNADA OU NENHUM DOS DOIS */
                CASE
                    WHEN (
                        (INTERVALOS.IDDIAOCORRENCIA_INICIO IN ('FA', 'DA') AND INTERVALOS.IDDIAOCORRENCIA_FIM NOT IN ('FA', 'DA')) OR
                        (INTERVALOS.IDDIAOCORRENCIA_FIM IN ('FS', 'DS') AND INTERVALOS.IDDIAOCORRENCIA_INICIO NOT IN ('FS', 'DS') ) OR
                        (TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') <> TO_CHAR(INTERVALOS.HORARIO_INICIO, 'DD/MM/YYYY') AND INTERVALOS.IDDIAOCORRENCIA_INICIO IN ('FC', 'DC') AND INTERVALOS.IDDIAOCORRENCIA_FIM IN ('FC', 'DC'))
                    ) THEN
                        'INTERJORNADA'
                    WHEN MOD(INTERVALOS.NRORDER_INTERVALO, 2) = 0 THEN
                        'INTRAJORNADA'
                    ELSE
                        ''
                END TIPO_OCORRENCIA, /* TEMPO MINIMO DE DESCANSO ENTRE JORNADAS, DEFINIDO NOS PARAMETROS DA ORGANIZACAO */
                ROUND(TO_NUMBER(SUBSTR(PO.HRTEMPODESCANSODIARIO, 0, 2)) +(TO_NUMBER(SUBSTR(PO.HRTEMPODESCANSODIARIO, 4, 5)) / 60), 5) AS HRTEMPODESCANSODIARIO,
                /* TEMPO A PROJETAR */
                CASE
                    WHEN OC.NRTIPOPROGOCORRENCIA IN (20, 26)
                         AND OC.NRINTERVALOHORARIO IS NOT NULL THEN
                        (
                            SELECT
                                ROUND(TO_NUMBER(SUBSTR(HRPROJETARINTERVALO, 0, 2)) + (TO_NUMBER(SUBSTR(HRPROJETARINTERVALO, 3, 4)) / 60), 5)
                            FROM
                                GPE_INTERVALOSHORARIO
                            WHERE
                                NRORG = INTERVALOS.NRORG
                                AND NRINTERVALOHORARIO = OC.NRINTERVALOHORARIO
                        )
                    ELSE
                        0
                END TEMPO_ALMOCO_HORARIO
            FROM
                ( /* SELECT QUE AGRUPA AS MARCACOES POR INTERVALOS, DUAS A DUAS */
                    SELECT
                        BATIDAS_DIA.*,
                        BATIDAS_DIA.DTHRAJUSTADA AS HORARIO_INICIO,
                        LEAD(BATIDAS_DIA.DTHRAJUSTADA, 1, TO_DATE('01/01/0001')) OVER(
                            PARTITION BY BATIDAS_DIA.NRVINCULOM
                            ORDER BY
                                BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DTHRAJUSTADA
                        ) HORARIO_FIM,
                        BATIDAS_DIA.IDDIAOCORRENCIA AS IDDIAOCORRENCIA_INICIO,
                        LEAD(BATIDAS_DIA.IDDIAOCORRENCIA, 1) OVER(
                            PARTITION BY BATIDAS_DIA.NRVINCULOM
                            ORDER BY
                                BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DTHRAJUSTADA
                        ) IDDIAOCORRENCIA_FIM,
                        BATIDAS_DIA.NRMARCACAOPONTO AS NRMARCACAOPONTO_INICIO,
                        ROW_NUMBER() OVER(
                            PARTITION BY BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DATA_APURACAO
                            ORDER BY
                                BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DTHRAJUSTADA
                        ) AS NRORDER_INTERVALO
                    FROM BATIDAS_DIA
                ) INTERVALOS /* OCORRENCIAS ENCONTRADAS PARA O INTERVALO */
                LEFT JOIN PTO_PROGOCORRENCIA OC ON OC.NRORG = INTERVALOS.NRORG
                                                   AND OC.NRMARCACAOPONTO = INTERVALOS.NRMARCACAOPONTO_INICIO
                                                   AND OC.IDATIVO = 'S' /* PARAMETROS DA ORGANIZACAO */
                LEFT JOIN GPE_PARAMORG PO ON PO.NRORG = INTERVALOS.NRORG
            WHERE /* IMPEDE QUE EXISTAM MARCACAOES SEM HORARIO FIM */
                TO_CHAR(INTERVALOS.HORARIO_FIM, 'DD/MM/YYYY') <> '01/01/0001'
        ) INTERVALOS_PROCESSADOS
)

/* UNION DOS DOIS SELECTS */
SELECT
    OCORRENCIAS.*,
    LIST_BATIDAS.BATIDAS
FROM
    ( /* SELECT QUE GARANTE QUE APENAS INTERVALOS COM OCORRENCIA SEJAM BUSCADOS */
        SELECT
            NRORG,
            NRVINCULOM,
            NMVINCULOM,
            NRPISPASEPPES,
            NMVINCULOM_NOTGROUPED,
            NRTIPOVINCULOM,
            NMTIPOVINCULOH,
            NRSITUFUNCM,
            NMSITUFUNCH,
            HORARIO_INICIO,
            IDDIAOCORRENCIA_INICIO,
            HORA_INICIO,
            DATA_INICIO,
            DATA_INICIO_FILTER,
            HORARIO_FIM,
            IDDIAOCORRENCIA_FIM,
            HORA_FIM,
            DATA_FIM,
            DATA_FIM_FILTER,
            DIFF_HOURS,
            DIFF_TIME,
            TIPO_OCORRENCIA,
            HRTEMPODESCANSODIARIO,
            TEMPO_ALMOCO_HORARIO,
            OBSERVACAO
        FROM
            INTERVALOS
        WHERE
            /* GARANTE QUE APENAS INTERVALOS COM OCORRENCIAS SEJAM BUSCADOS */
            TIPO_OCORRENCIA IS NOT NULL
            
        UNION ALL
        
        /* SELECT QUE BUSCA OCORRENCIAS QUE NAO DEPENDEM DOS INTERVALOS - ABONO, IMPAR, EXTRA */
        SELECT
            NRORG,
            NRVINCULOM,
            NMVINCULOM,
            NRPISPASEPPES,
            NMVINCULOM_NOTGROUPED,
            NRTIPOVINCULOM,
            NMTIPOVINCULOH,
            NRSITUFUNCM,
            NMSITUFUNCH,
            DTDATA AS HORARIO_INICIO,
            NULL AS IDDIAOCORRENCIA_INICIO,
            NULL AS HORA_INICIO,
            TO_CHAR(DTDATA, 'DD/MM/YYYY') AS DATA_INICIO,
            TO_CHAR(DTDATA, 'YYYY-MM-DD') AS DATA_INICIO_FILTER,
            NULL AS HORARIO_FIM,
            NULL AS IDDIAOCORRENCIA_FIM,
            NULL AS HORA_FIM,
            NULL AS DATA_FIM,
            NULL AS DATA_FIM_FILTER,
            CASE
                WHEN TIPO_OCORRENCIA = 'EXTRA'  THEN
                    VALOR_EXTRA_HOURS
                WHEN TIPO_OCORRENCIA = 'ATRASO' THEN
                    VALOR_ATRASO_HOURS
                ELSE
                    NULL
            END AS DIFF_HOURS,
            CASE
                WHEN TIPO_OCORRENCIA = 'EXTRA'  THEN
                    VALOR_EXTRA_TIME
                WHEN TIPO_OCORRENCIA = 'ATRASO' THEN
                    VALOR_ATRASO_TIME
                ELSE
                    NULL
            END AS DIFF_TIME,
            TIPO_OCORRENCIA   AS TIPO_OCORRENCIA,
            NULL AS HRTEMPODESCANSODIARIO,
            NULL AS TEMPO_ALMOCO_HORARIO,
            OBSERVACAO
        FROM
            TOTALIZADORES_POS
        UNPIVOT (OBSERVACAO FOR TIPO_OCORRENCIA IN ( ABONO, QTD_MARCACOES_IMPAR, EXTRA, FALTA, ATRASO, TROCA, QTD_MARCACOES_MAIOR, QTD_MARCACOES_MENOR, QTMENOR_COMP, QTMAIOR_COMP ))
    ) OCORRENCIAS
    
    /* BUSCA POR INFORMACOES PARA TODOS OS DADOS ALEM DO UNION */
    
    /* RETORNA AS BATIDAS REALIZADAS NO DIA */
    LEFT JOIN (
        SELECT
            BATIDAS_DIA.NRVINCULOM,
            BATIDAS_DIA.DATA_APURACAO,
            LISTAGG(TO_CHAR(BATIDAS_DIA.DTHRAJUSTADA, 'HH24:MI'), ' - ') WITHIN GROUP (ORDER BY BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DTHRAJUSTADA) BATIDAS
        FROM BATIDAS_DIA
        GROUP BY BATIDAS_DIA.NRVINCULOM, BATIDAS_DIA.DATA_APURACAO
    ) LIST_BATIDAS ON LIST_BATIDAS.NRVINCULOM = OCORRENCIAS.NRVINCULOM AND TRUNC(LIST_BATIDAS.DATA_APURACAO) = TRUNC(OCORRENCIAS.HORARIO_INICIO)
WHERE
    (
        (INSTR(:P_TIPOOCORRENCIA, ',' || TIPO_OCORRENCIA || ',') ) > 0
        OR :P_TIPOOCORRENCIA IS NULL
    ) AND
    /* OPCOES DE FILTRO: MENOR_IGUAL, MAIOR_IGUAL, IGUAL */
    (
        :P_CONDICAO IS NOT NULL AND (
            (
                :P_CONDICAO = 'MAIOR_IGUAL'
                 AND DIFF_HOURS >= ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) + (TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5)
            ) OR (
                :P_CONDICAO = 'MENOR_IGUAL'
                 AND DIFF_HOURS <= ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) +(TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5)
            ) OR (
                :P_CONDICAO = 'IGUAL'
                AND DIFF_HOURS = ROUND(TO_NUMBER(SUBSTR(:P_VALOR, 0, 2)) +(TO_NUMBER(SUBSTR(:P_VALOR, 4, 2)) / 60), 5)
            )
        ) OR :P_CONDICAO IS NULL
    )
ORDER BY
    NMVINCULOM,
    TRUNC(HORARIO_INICIO),
    HORARIO_FIM
NULLS LAST